plugin.Load = function()
	--Turbine.Shell.WriteLine('Plugin.Load');
end

plugin.Unload = function()
	--Turbine.Shell.WriteLine('Plugin.Unload');
end


NoRezWindow = class(Turbine.UI.Window);

function NoRezWindow:Constructor()
	--Turbine.Shell.WriteLine('Window:Constructor');
	Turbine.UI.Window.Constructor(self);

	local top = Turbine.UI.Display:GetWidth() / 2 - 100;
	local left = Turbine.UI.Display:GetHeight() / 2 - 100;

	local data = {
        position = {top, left};
        channel = "/say";
    };
    
	self:SetEnabled(true);
	self:SetPosition(unpack(data.position));
	self:SetSize(62, 46);
	self:SetVisible(true);
	self.settings = data;

	local quickSlot = Turbine.UI.Lotro.Quickslot();
	quickSlot:SetParent(self);
	quickSlot:SetAllowDrop(false);
	quickSlot:SetPosition(0, 0);
	quickSlot:SetSize(46, 46);
	quickSlot:SetMouseVisible(true);

	quickSlot.MouseEnter = function(sender, args)
		--Turbine.Shell.WriteLine("MouseEnter");
		quickSlot:SetWantsUpdates(true);
	end
	quickSlot.MouseLeave = function(sender, args)
		--Turbine.Shell.WriteLine("MouseLeave");
		quickSlot:SetWantsUpdates(false);
	end
	quickSlot.Update = function(sender, args)
		--Turbine.Shell.WriteLine("MouseHover");

		local player = Turbine.Gameplay.LocalPlayer:GetInstance();

		local trained = player:GetTrainedSkills();
		local names = {
			["Escape from Darkness"] = true,
			["Overbearing"] = true,
			["Rally!"] = true,
			["Do Not Fall This Day"] = true,
			["On Your Feet!"] = true,
		}

		local skill = nil;

		for i = 1, trained:GetCount() do
			local i_skill = trained:GetItem(i);
			local i_name = i_skill:GetSkillInfo():GetName();
			--Turbine.Shell.WriteLine("Checking: " .. i_name);
			if names[i_name] then
				--Turbine.Shell.WriteLine(string.format("Found: %s", i_name));
				name = i_name;
				skill = i_skill;
				break;
			end
		end

		if not skill then
			return;
		end

		local now = Turbine.Engine.GetGameTime()
		local remaining = math.ceil(skill:GetResetTime() - now);
		local command = nil;

		if remaining < 0 then
			command = self.settings.channel .. " <rgb=#00FF1F>" .. name .. " is ready</rgb>";
		else
			command = self.settings.channel .. " <rgb=#FF0800>" .. name .. " Cooldown:</rgb> <rgb=#00E0FF>" .. remaining .. " seconds</rgb>";
		end
		local shortcut = Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias, command);
		quickSlot:SetShortcut(shortcut);
	end

	local overlay = Turbine.UI.Control();
	overlay:SetParent(self);
	overlay:SetBackground("Vanaei/NoRez4U/meh.tga");
	overlay:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend);
	overlay:SetBackColorBlendMode(Turbine.UI.BlendMode.None);
	overlay:SetMouseVisible(false);
	overlay:SetPosition(0, 0);
	overlay:SetSize(46, 46);

	local channelMenu = Turbine.UI.ContextMenu();
	local say = Turbine.UI.MenuItem("Say");
	local raid = Turbine.UI.MenuItem("Raid");
	local fellowship = Turbine.UI.MenuItem("Fellowship");
	local kinship = Turbine.UI.MenuItem("Kinship");
	local officer = Turbine.UI.MenuItem("Officer");
	local tribe = Turbine.UI.MenuItem("Tribe (Monster)");
	local group = Turbine.UI.MenuItem("Group (Monster)");

	local items = channelMenu:GetItems();
	items:Add(say);
	items:Add(raid);
	items:Add(fellowship);
	items:Add(kinship);
	items:Add(officer);
	items:Add(tribe);
	items:Add(group);
	function SelectMenuItem(selected, channel)
		self.settings.channel = channel;
		for i = 1, items:GetCount() do
			local item = items:Get(i);
			item:SetChecked(item == selected);
		end
	end

	SelectMenuItem(say, "/say");

	say.Click = function(sender, args)
		SelectMenuItem(say, "/say");
	end
	raid.Click = function(sender, args)
		SelectMenuItem(raid, "/ra");
	end
	fellowship.Click = function(sender, args)
		SelectMenuItem(fellowship, "/f");
	end
	kinship.Click = function(sender, args)
		SelectMenuItem(kinship, "/k");
	end
	officer.Click = function(sender, args)
		SelectMenuItem(officer, "/o");
	end
	tribe.Click = function(sender, args)
		SelectMenuItem(tribe, "/tr");
	end
	group.Click = function(sender, args)
		SelectMenuItem(group, "/g");
	end

	local channelButton = Turbine.UI.Control();
	channelButton:SetParent(self);
	channelButton:SetBackground(0x41007E1E);
	channelButton:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend);
	channelButton:SetBackColorBlendMode(Turbine.UI.BlendMode.None);
	channelButton:SetMouseVisible(true);
	channelButton:SetPosition(40, 33);
	channelButton:SetSize(16, 16);
	channelButton.MouseEnter = function(sender, args)
		--Turbine.Shell.WriteLine("MouseEnter");
		channelButton:SetBackground(0x41007E1F);
	end
	channelButton.MouseDown = function(sender, args)
		--Turbine.Shell.WriteLine("MouseDown");
		channelButton:SetBackground(0x41007E1D);
		channelMenu.x, channelMenu.y = Turbine.UI.Display.GetMousePosition();
		channelMenu:ShowMenu();
	end
	channelButton.MouseUp = function(sender, args)
		--Turbine.Shell.WriteLine("MouseUp");
		channelButton:SetBackground(0x41007E1F);
	end
	channelButton.MouseLeave = function(sender, args)
		--Turbine.Shell.WriteLine("MouseLeave");
		channelButton:SetBackground(0x41007E1E);
	end

	local dleft, dtop;
	local dragButton = Turbine.UI.Control();
	dragButton:SetParent(self);
	dragButton:SetBackground(0x41007E0C);
	dragButton:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend);
	dragButton:SetBackColorBlendMode(Turbine.UI.BlendMode.None);
	dragButton:SetMouseVisible(true);
	dragButton:SetPosition(40, 0);
	dragButton:SetSize(16, 16);
	dragButton.MouseDown = function(sender, args)
		--Turbine.Shell.WriteLine("MouseDown");
		local mleft, mtop = Turbine.UI.Display.GetMousePosition();
		local left, top = self:GetPosition();
		dleft = left - mleft;
		dtop = top - mtop;
		dragButton:SetWantsUpdates(true);
	end
	dragButton.MouseUp = function(sender, args)
		--Turbine.Shell.WriteLine("MouseUp");
		dragButton:SetWantsUpdates(false);
	end
	dragButton.Update = function(sender, args)
		local mleft, mtop = Turbine.UI.Display.GetMousePosition();
		local left = mleft + dleft;
		local top = mtop + dtop;
		self:SetPosition(left, top);
		self.settings.position = { left, top };
	end

	Turbine.PluginData.Load(Turbine.DataScope.Character, "NoRez4U", function(data)
        if (data) then
            data = ImportTable(data);
            self:SetPosition(unpack(data.position));
            self.settings = data;
        end
    end);

end

function NoRezWindow:PositionChanged()
    local left, top = self:GetPosition();
    self.settings.position = { left, top };
    self:SaveSettings();
end

function NoRezWindow:SaveSettings()
    Turbine.PluginData.Save(Turbine.DataScope.Character, "NoRez4U", self.settings);
end

win = NoRezWindow();